<?php
// In your controller
namespace App\Http\Session;
namespace App\Controller;
use Cake\Cache\Cache;

use Cake\Http\Session\DatabaseSession;

use Cake\Core\Configure;
use Cake\Http\Exception\ForbiddenException;
use Cake\Http\Exception\NotFoundException;
use Cake\Http\Response;
use Cake\View\Exception\MissingTemplateException;
use Cake\Event\Event;
use Cake\Event\EventInterface;

use MongoDB\Client as Mongo;
// use Shapefile\Shapefile;
// use Shapefile\ShapefileException;
// use Shapefile\ShapefileReader;


use PhpOffice\PhpSpreadsheet\Spreadsheet; // ← PhpSpreadsheet class
use PhpOffice\PhpSpreadsheet\Writer\Xlsx; // ← PhpSpreadsheet class
use PhpOffice\PhpSpreadsheet\IOFactory;
use Cake\Datasource\ConnectionManager;

class FetchDataController extends AppController
{
    public function fetchDataFromMongoDB()
    {
        $connection = new Mongo;// Assuming 'mongo' is the name of your MongoDB connection in database.php
        
        // Define the filter criteria
        $filter = [
            'DeviceDate' => [
                '$gte' => '2023-03-03 09:00:00',
                '$lte' => '2023-03-03 10:00:00'
            ]
        ];

        // Define the aggregation pipeline
        $pipeline = [
            ['$match' => $filter],
            ['$group' => [
                '_id' => '$StationID',
                'totalHourlyRainfall' => ['$sum' => '$HourlyRainfall']
            ]]
        ];

        // Execute the aggregation pipeline
        $results = $connection->executeAggregation('aws_arg_data', $pipeline);

        // Output the results
        foreach ($results as $result) {
            $this->log("StationID: " . $result->_id . ", Total Hourly Rainfall: " . $result->totalHourlyRainfall);
        }
    }
}
?>
